#
empty =
space =$(empty) $(empty)

export ARMV7OBJDIR ?= ./obj
export ARMV7BINDIR ?= ./bin
export ARMV7LIBDIR ?= ./lib
export ARMV7SALIBDIR ?= ./lib

DPI_DEMO_SRC_DIR ?= $(PWD)
# INCLUDE Directories
SA_INSTALL_PATH ?= $(PDK_INSTALL_PATH)/ti/drv/sa
QMSS_INC_DIR ?= $(PDK_INSTALL_PATH)/ti/drv/qmss
CPPI_INC_DIR ?= $(PDK_INSTALL_PATH)/ti/drv/cppi
RM_INC_DIR ?= $(PDK_INSTALL_PATH)/ti/drv/rm
#NETAPI_INC_DIR ?=  $(NETAPI_INSTALL_PATH)/ti/runtime/netapi
NETAPI_INC_DIR ?=  $(NETAPI_INSTALL_PATH)
#HPLIB_INC_DIR ?=  $(HPLIB_INSTALL_PATH)/ti/runtime/hplib
HPLIB_INC_DIR ?=  $(HPLIB_INSTALL_PATH)
NWAL_INSTALL_PATH ?= $(PDK_INSTALL_PATH)/ti/drv/nwal
PKTLIB_INSTALL_PATH ?= $(PDK_INSTALL_PATH)/ti/runtime/pktlib
NAVL_LIB_DIR ?= $(DPI_DEMO_SRC_DIR)/../lib
# Set NETAPI INSTALL PATH to Transport SDK for default

#NT_RM_OBJS = $(ARMV7OBJDIR)/netapi/utils/sockutils.o  $(ARMV7OBJDIR)/netapi/utils/netapi_util_rm.o

#TRIE_OBJS=$(ARMV7OBJDIR)/netapi/test/trie.o


DPI_DEMO_OBJS= $(ARMV7OBJDIR)/dpi_demo_git/src/dpi_demo.o $(ARMV7OBJDIR)/dpi_demo_git/src/navl_wrapper.o $(ARMV7OBJDIR)/dpi_demo_git/src/navl_external_posix.o

# Support Libraries used by dpi-demo 
CSL_DEVICE ?= -DDEVICE_K2E -DNSS_GEN2
QMSS_LIB = -lqmss
CPPI_LIB = -lcppi
PA_LIB = -lpa2
NWAL_LIB = -lnwalsa_k2e
SA_LIB = -lsa
RM_LIB = -lrm
PKTLIB_LIB = -lpktlib
NETAPI_LIB =-lnetapi_k2e
HP_LIB = -lhplib_k2e
NAVL_LIB = -lnavl

local_base=/usr/local
LDFLAGS = -L. -L$(local_base)/lib

LIBS = -static $(QMSS_LIB) $(CPPI_LIB) $(PA_LIB) $(PKTLIB_LIB) $(NETAPI_LIB) $(HP_LIB) $(SA_LIB) $(NWAL_LIB) $(RM_LIB) -Wl,-Bdynamic

LIBS += $(NAVL_LIB) -lstdc++ -lgcc_s
EXE_EXTN =

SYSTYPE:=$(shell uname)
ifeq ($(SYSTYPE), Linux)
LIBS += -ldl -lm
else
LIBS += -lexecinfo
endif

ifdef CROSS_TOOL_INSTALL_PATH
## Support backwards compatibility with KeyStone1 approach
 CC = $(CROSS_TOOL_INSTALL_PATH)/$(CROSS_TOOL_PRFX)gcc
 AC = $(CROSS_TOOL_INSTALL_PATH)/$(CROSS_TOOL_PRFX)as
 AR = $(CROSS_TOOL_INSTALL_PATH)/$(CROSS_TOOL_PRFX)ar
 LD = $(CROSS_TOOL_INSTALL_PATH)/$(CROSS_TOOL_PRFX)gcc
endif

INCLUDE = -I. -I$(local_base)/include -I../ -I$(HPLIB_INC_DIR) -I$(NETAPI_INC_DIR) -I$(PDK_INSTALL_PATH) -I$(NWAL_INSTALL_PATH) -I$(PKTLIB_INSTALL_PATH) -I$(SA_INSTALL_PATH) -I$(QMSS_INC_DIR) -I$(CPPI_INC_DIR) -I$(RM_INC_DIR) $(CSL_DEVICE)

CFLAGS += $(DEBUG_FLAG) -D__ARMv7 -D_VIRTUAL_ADDR_SUPPORT -D__LINUX_USER_SPACE -D_LITTLE_ENDIAN=1 -DNWAL_ENABLE_SA -DMAKEFILE_BUILD -D _GNU_SOURCE
# Linker options
INTERNALLINKDEFS = -Wl,--start-group $(LIBS) -Wl,--end-group -lrt -pthread  -L$(ARMV7LIBDIR) -L$(ARMV7SALIBDIR) -L$(NAVL_LIB_DIR)

all: tests 

tests: $(ARMV7BINDIR)/dpi_demo_git/demo/.created $(ARMV7BINDIR)/dpi_demo_git/demo/dpi_demo_$(DEVICE)

clean:	
	rm -f $(ARMV7OBJDIR)/dpi_demo/demo/*.o
	rm -f $(ARMV7BINDIR)/dpi_demo/demo/*

$(ARMV7OBJDIR)/dpi_demo_git/src/%.o: %.c $(ARMV7OBJDIR)/dpi_demo_git/src/.created
	@echo compiling $<
	$(CC) -c  $(CFLAGS) $(INCLUDE) $<  -o $@

$(ARMV7OBJDIR)/dpi_demo_git/src/.created:
	@mkdir -p $(ARMV7OBJDIR)/dpi_demo_git/src/

$(ARMV7BINDIR)/dpi_demo_git/demo/.created:
	@mkdir -p $(ARMV7BINDIR)/dpi_demo_git/demo/

$(ARMV7BINDIR)/dpi_demo_git/demo/dpi_demo_$(DEVICE): $(DPI_DEMO_OBJS)
	echo 'test123'
	#$(CC) $(LDFLAGS) $(DPI_DEMO_OBJS) $(INTERNALLINKDEFS) $(INCLUDE) -rdynamic ../lib/libnavl.so -o $(ARMV7BINDIR)/dpi_demo_git/demo/dpi_demo_$(DEVICE)$(EXE_EXTN)
	$(CC) $(LDFLAGS) $(DPI_DEMO_OBJS) $(INTERNALLINKDEFS) $(INCLUDE) -o $(ARMV7BINDIR)/dpi_demo_git/demo/dpi_demo_$(DEVICE)$(EXE_EXTN)
